﻿define("gl-translations/component/command/AutoSubmit", [
    "dojox/layout/ResizeHandle",
    "dojo/on",
    "dojo/_base/connect",
    "dojo/parser",
    "dojo/_base/lang",
    "epi/routes",
    "dojo/when",
    "dojo/topic",
    "epi/string",
    "dojo/_base/declare",
    "epi/shell/widget/dialog/Alert",
    "epi/dependency",
    "epi/shell/command/_Command",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/widget/_HasChildDialogMixin",
    "epi-cms/core/ContentReference",
    "epi/shell/ViewSettings",
    "epi/shell/socket/hub",
    "epi/shell/command/_SelectionCommandMixin",
    "epi-cms/_ContentContextMixin",
    "epi-cms/contentediting/ContentActionSupport"
],

    function (
        ResizeHandle, on,
        connect,
        parser,
        lang,
        routes,
        when,
        topic,
        epistring,
        declare,
        Alert,
        dependency,
        _Command,
        TypeDescriptorManager,
        _HasChildDialogMixin,
        ContentReference,
        ViewSettings,
        hub,
        _SelectionCommandMixin,
        _ContentContextMixin,
        ContentActionSupport
    ) {

        return declare([_Command, _HasChildDialogMixin, _SelectionCommandMixin, _ContentContextMixin], {

            label: "Auto Submit Current Item",

            iconClass: "epi-iconPlus",
            projectJobId: null,
            currentContext: null,
            dataObject: null,
            constructor: function () {

            },

            setLabel: function (newLabel) {
                this.label = newLabel;
            },
            _execute: function () {

                this.currentContext = this._currentContext.id;
                this.store = this.store || dependency.resolve("epi.storeregistry").get("globallink.translationprojectstore");
                var promise = this.store.get(this.currentContext+":0:autoSubmit");
                var self = this;
                when(promise, function (value) {
                    if (value && value.status && value.status == 400) {
                        var dialog = new Alert({
                            heading: "Cannot autosubmit",
                            destroyOnHide: true,
                            description: epistring.toHTML(value.message)
                        });
                        dialog.show();
                    } else {
                        var dialog = new Alert({
                            heading: "Success",
                            destroyOnHide: true,
                            description: "Selected content will be sent in background"
                        });
                        dialog.show();
                    }
                }, function (error) {
                    var dialog = new Alert({
                        heading: "Cannot create new job",
                        destroyOnHide: true,
                        description: epistring.toHTML(error.xhr.statusText)
                    });
                    dialog.show();
                });
            },


            _onModelChange: function () {

                if (this._currentContext) {
                    this.currentContext = this._currentContext.id;
                }
                this.store = this.store || dependency.resolve("epi.storeregistry").get("globallink.translationprojectstore");
var obj = this;
                var promise = this.store.get("0:0:isEnabled");
 when(promise, function (value) {
                    obj.set("isAvailable", value.contentLink=="1");
                }, function (error) {
                    obj.set("isAvailable", true);
                });

                //this.set("isAvailable", true);
                this.set("canExecute", this._currentContext);
            },
            
        });
    });
