﻿define("gl-translations/component/ExtendedCheckBoxListEditor", [
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/dom-construct",
    "epi-cms/contentediting/editors/CheckBoxListEditor"
], function (
    declare,
    array,
    domConstruct,
    _CheckBoxListEditor
) {
        return declare(_CheckBoxListEditor, {
            filter: null,
            allSelections: null,
            _setFilterAttr: function (filter) {
                this._set("filter", filter);
                this.set("selections", this.allSelections);
            },

            _setSelectionsAttr: function (selections) {
                this.allSelections = selections;
                this._set("selections", array.filter(selections, this.filter || function () {
                    return true;
                }, this));

                this._checkboxes = [];
                domConstruct.empty(this.domNode);
                array.forEach(this.selections, this._addCheckBoxForItem, this);
                this.set("value", this.value);
            },
            _calculateValue: function () {
                var values = [];
                var storeChecked = this.valueIsInclusive;
                array.forEach(this._checkboxes, function (checkbox) {
                    if (storeChecked === checkbox.checked) {
                        values.push(checkbox.value);
                    }
                });

                this._set("value", this.valueIsCsv ? values.join(",") : values);
            },
            _setValueAttr: function (value) {
                this._set("value", value);

                var values2 = [];
                var values = [];
                if (value) {
                    values2 = this.valueIsCsv ? value.split(",") : value;
                    array.forEach(values2, function (v) {
                        values.push(v.split(':')[0]);
                    });
                }
                values = values2;


                var checkValues = this.valueIsInclusive;
                var compareCheckboxValue = this._compareCheckboxValue;

                array.forEach(this._checkboxes, function (checkbox) {
                    checkbox.set("checked", checkValues === array.some(values, function (v) {
                        return compareCheckboxValue(checkbox, v);
                    }));
                });
            },
        });
    });